with GNATCOM.Dispinterface;

package MSHTML.IHTMLTable_Interface is

   type IHTMLTable_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IHTMLTable_Type);

   function Pointer (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTable;

   procedure Attach (This    : in out IHTMLTable_Type;
                     Pointer : in     Pointer_To_IHTMLTable);

   procedure Put_cols
     (This : IHTMLTable_Type;
      p    : Interfaces.C.long);

   function Get_cols
     (This : IHTMLTable_Type)
     return Interfaces.C.long;

   procedure Put_border
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_border
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_frame
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True);

   function Get_frame
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_rules
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True);

   function Get_rules
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_cellSpacing
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_cellSpacing
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_cellPadding
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_cellPadding
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_background
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True);

   function Get_background
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_bgColor
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_bgColor
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderColor
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderColor
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderColorLight
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderColorLight
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderColorDark
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderColorDark
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_align
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True);

   function Get_align
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR;

   procedure refresh
     (This : IHTMLTable_Type);

   function Get_rows
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLElementCollection;

   procedure Put_width
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_width
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_height
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_height
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_dataPageSize
     (This : IHTMLTable_Type;
      p    : Interfaces.C.long);

   function Get_dataPageSize
     (This : IHTMLTable_Type)
     return Interfaces.C.long;

   procedure nextPage
     (This : IHTMLTable_Type);

   procedure previousPage
     (This : IHTMLTable_Type);

   function Get_tHead
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTableSection;

   function Get_tFoot
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTableSection;

   function Get_tBodies
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLElementCollection;

   function Get_caption
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTableCaption;

   function createTHead
     (This : IHTMLTable_Type)
     return GNATCOM.Types.Pointer_To_IDispatch;

   procedure deleteTHead
     (This : IHTMLTable_Type);

   function createTFoot
     (This : IHTMLTable_Type)
     return GNATCOM.Types.Pointer_To_IDispatch;

   procedure deleteTFoot
     (This : IHTMLTable_Type);

   function createCaption
     (This    : IHTMLTable_Type)
     return Pointer_To_IHTMLTableCaption;

   procedure deleteCaption
     (This : IHTMLTable_Type);

   function insertRow
     (This  : IHTMLTable_Type;
      index : Interfaces.C.long)
     return GNATCOM.Types.Pointer_To_IDispatch;

   procedure deleteRow
     (This  : IHTMLTable_Type;
      index : Interfaces.C.long);

   function Get_readyState
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_onreadystatechange
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onreadystatechange
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT;

end MSHTML.IHTMLTable_Interface;

